declare type Dictionary = {
    [key: string]: any;
};
declare type PrimMeta<T> = {
    isPrimAction: boolean;
    namespace: string;
    updaterName: keyof PrimUpdaterImpls<T>;
};
declare type PrimAction<T> = {
    type: string;
    payload: any;
    meta?: PrimMeta<T>;
    error?: any;
};
interface UpdateParam<T extends Dictionary> {
    state: T;
    getDefaultState: Function;
    action: PrimAction<T>;
}
interface PrimUpdaterImpls<T extends Dictionary> {
    initState: (p: UpdateParam<T>) => Dictionary;
    setState: (p: UpdateParam<T>) => Dictionary;
    mergeState: (p: UpdateParam<T>) => Dictionary;
}
interface PrimUpdaters<T extends Dictionary> {
    initState: (p?: Dictionary) => PrimAction<T>;
    setState: (p: Dictionary | ((s: Readonly<T>) => Dictionary)) => PrimAction<T>;
    mergeState: (p: Dictionary) => PrimAction<T>;
}
declare type ThunkCallback<T> = (dispatch: ((action: PrimAction<T>) => void), getState: () => Dictionary) => void;
export default function createSlice<T extends {
    [key: string]: (...args: any) => PrimAction<P> | ThunkCallback<P>;
}, P extends Dictionary>(namespace: string, getDefaultState: () => P, creator: (updaters: PrimUpdaters<P>) => T): {
    actions: T;
    reducer: {
        [x: string]: (state?: Dictionary, action?: PrimAction<P>) => any;
    };
    selector: (state: Dictionary) => P;
};
export {};
